MODULE ioipsl
  
  IMPLICIT NONE

  PUBLIC ::  ipslerr, ipslerr_p
  
  INTEGER, PARAMETER :: numout=6
  INTEGER :: ipslout=6, ilv_cur=0, ilv_max=0
  LOGICAL :: ioipsl_debug=.FALSE., lact_mode=.TRUE.
  
CONTAINS
  !
  SUBROUTINE ipslerr (plev,pcname,pstr1,pstr2,pstr3)
!---------------------------------------------------------------------
!! The "ipslerr" routine
!! allows to handle the messages to the user.
!!
!! INPUT
!!
!! plev   : Category of message to be reported to the user
!!          1 = Note to the user
!!          2 = Warning to the user
!!          3 = Fatal error
!! pcname : Name of subroutine which has called ipslerr
!! pstr1   
!! pstr2  : Strings containing the explanations to the user
!! pstr3
!---------------------------------------------------------------------
    IMPLICIT NONE
!-
    INTEGER :: plev
    CHARACTER(LEN=*) :: pcname,pstr1,pstr2,pstr3
!-
    CHARACTER(LEN=30),DIMENSION(3) :: pemsg = &
         &  (/ "NOTE TO THE USER FROM ROUTINE ", &
         &     "WARNING FROM ROUTINE          ", &
         &     "FATAL ERROR FROM ROUTINE      " /)
!---------------------------------------------------------------------
    IF ( (plev >= 1).AND.(plev <= 3) ) THEN
       ilv_cur = plev
       ilv_max = MAX(ilv_max,plev)
       WRITE(ipslout,'(/,A," ",A)') TRIM(pemsg(plev)),TRIM(pcname)
       WRITE(ipslout,'(3(" --> ",A,/))') TRIM(pstr1),TRIM(pstr2),TRIM(pstr3)
    ENDIF
    IF ( (plev == 3).AND.lact_mode) THEN
       WRITE(ipslout,'("Fatal error from IOIPSL. STOP in ipslerr with code")')
       STOP 1
    ENDIF
!---------------------
  END SUBROUTINE ipslerr
!
  SUBROUTINE ipslerr_p (plev,pcname,pstr1,pstr2,pstr3)
!---------------------------------------------------------------------
!! The "ipslerr" routine
!! allows to handle the messages to the user.
!!
!! INPUT
!!
!! plev   : Category of message to be reported to the user
!!          1 = Note to the user
!!          2 = Warning to the user
!!          3 = Fatal error
!! pcname : Name of subroutine which has called ipslerr
!! pstr1   
!! pstr2  : Strings containing the explanations to the user
!! pstr3
!---------------------------------------------------------------------
    IMPLICIT NONE
!-
    INTEGER :: plev
    CHARACTER(LEN=*) :: pcname,pstr1,pstr2,pstr3
!-
    CHARACTER(LEN=30),DIMENSION(3) :: pemsg = &
         &  (/ "NOTE TO THE USER FROM ROUTINE ", &
         &     "WARNING FROM ROUTINE          ", &
         &     "FATAL ERROR FROM ROUTINE      " /)
!---------------------------------------------------------------------
    IF ( (plev >= 1).AND.(plev <= 3) ) THEN
       ilv_cur = plev
       ilv_max = MAX(ilv_max,plev)
       WRITE(ipslout,'(/,A," ",A)') TRIM(pemsg(plev)),TRIM(pcname)
       WRITE(ipslout,'(3(" --> ",A,/))') TRIM(pstr1),TRIM(pstr2),TRIM(pstr3)
    ENDIF
    IF ( (plev == 3).AND.lact_mode) THEN
       WRITE(ipslout,'("Fatal error from IOIPSL. STOP in ipslerr with code")')
       STOP 1
    ENDIF
!---------------------
  END SUBROUTINE ipslerr_p
END MODULE ioipsl

 
